<?php

declare(strict_types=1);

namespace App\Modules\CardOrder\Policies;

use App\Modules\CardOrder\Models\CardType;
use Illuminate\Auth\Access\HandlesAuthorization;
use Illuminate\Foundation\Auth\User as AuthUser;

class CardTypePolicy
{
    use HandlesAuthorization;

    public function viewAny(AuthUser $authUser): bool
    {
        return $authUser->can('ViewAny:CardType');
    }

    public function view(AuthUser $authUser, CardType $cardType): bool
    {
        return $authUser->can('View:CardType');
    }

    public function create(AuthUser $authUser): bool
    {
        return $authUser->can('Create:CardType');
    }

    public function update(AuthUser $authUser, CardType $cardType): bool
    {
        return $authUser->can('Update:CardType');
    }

    public function delete(AuthUser $authUser, CardType $cardType): bool
    {
        return $authUser->can('Delete:CardType');
    }

    public function restore(AuthUser $authUser, CardType $cardType): bool
    {
        return $authUser->can('Restore:CardType');
    }

    public function forceDelete(AuthUser $authUser, CardType $cardType): bool
    {
        return $authUser->can('ForceDelete:CardType');
    }

    public function forceDeleteAny(AuthUser $authUser): bool
    {
        return $authUser->can('ForceDeleteAny:CardType');
    }

    public function restoreAny(AuthUser $authUser): bool
    {
        return $authUser->can('RestoreAny:CardType');
    }

    public function replicate(AuthUser $authUser, CardType $cardType): bool
    {
        return $authUser->can('Replicate:CardType');
    }

    public function reorder(AuthUser $authUser): bool
    {
        return $authUser->can('Reorder:CardType');
    }
}
